<template>
        <card title="Register" icon="save_alt">
            <b-row slot='body' align-h="center">
                <b-col cols="8">
                    <form @submit.prevent="register">
                        <b-alert variant='danger' :show="1!==1">
                            <!--TODO: display complete form errors in a bs alert error-->
                        </b-alert>
                        <div v-show="!this.form.submitting || this.form.submitting">
                            <div class="form-group">
                                <label>Username</label>
                                <input type="text"
                                       v-model="form.username"
                                       name="username"
                                       class="form-control"
                                       v-model.trim="form.username" @input="$v.form.username.$touch()"
                                       :class="{ 'is-invalid': $v.form.username.$error }"/>
                                <div v-if="$v.form.username.$invalid && $v.form.username.$model" class="form-error">This is
                                    not a
                                    valid email...
                                </div>
                                <div v-if="!$v.form.username.required && $v.form.username.$anyDirty" class="form-error">This
                                    field
                                    is required
                                </div>
                            </div>
                            <div class="form-group">
                                <label>Email</label>
                                <input type="text"
                                       v-model="form.email"
                                       name="email"
                                       class="form-control"
                                       v-model.trim="form.email" @input="$v.form.email.$touch()"
                                       :class="{ 'is-invalid': $v.form.email.$error }"/>
                                <div v-if="!$v.form.email.email" class="form-error">This is not a valid email...</div>
                                <div v-if="!$v.form.email.isEmailAlreadyRegistered" class="form-error">This email is already
                                    registered
                                </div>
                                <div v-if="!$v.form.email.required && $v.form.email.$anyDirty" class="form-error">This field
                                    is
                                    required
                                </div>
                            </div>
                            <div class="form-group">
                                <label>Password</label>
                                <input type="password"
                                       v-model="form.password"
                                       name="password"
                                       class="form-control"
                                       v-model.trim="form.password" @input="$v.form.password.$touch()"
                                       :class="{ 'is-invalid': $v.form.password.$error }"/>
                                <div v-if="$v.form.password.$invalid" class="form-error"></div>
                                <div v-if="!$v.form.password.required && $v.form.password.$anyDirty" class="form-error">This
                                    field
                                    is required
                                </div>
                            </div>
                            <div class="form-group">
                                <label>Password confirmation</label>
                                <input type="password"
                                       v-model="form.password_confirmation"
                                       name="password_confirmation"
                                       class="form-control"
                                       v-model.trim="form.password_confirmation"
                                       @input="$v.form.password_confirmation.$touch()"
                                       :class="{ 'is-invalid': $v.form.password.$error }"/>
                                <div v-if="$v.form.password_confirmation.$invalid" class="form-error"></div>
                                <div v-if="!$v.form.password_confirmation.required && $v.form.password_confirmation.$anyDirty"
                                     class="form-error">This field is required
                                </div>
                            </div>
                        </div>

                        <div class="form-group">
                            <img v-show="this.form.submitting"
                                 src="data:image/gif;base64,R0lGODlhEAAQAPIAAP///wAAAMLCwkJCQgAAAGJiYoKCgpKSkiH/C05FVFNDQVBFMi4wAwEAAAAh/hpDcmVhdGVkIHdpdGggYWpheGxvYWQuaW5mbwAh+QQJCgAAACwAAAAAEAAQAAADMwi63P4wyklrE2MIOggZnAdOmGYJRbExwroUmcG2LmDEwnHQLVsYOd2mBzkYDAdKa+dIAAAh+QQJCgAAACwAAAAAEAAQAAADNAi63P5OjCEgG4QMu7DmikRxQlFUYDEZIGBMRVsaqHwctXXf7WEYB4Ag1xjihkMZsiUkKhIAIfkECQoAAAAsAAAAABAAEAAAAzYIujIjK8pByJDMlFYvBoVjHA70GU7xSUJhmKtwHPAKzLO9HMaoKwJZ7Rf8AYPDDzKpZBqfvwQAIfkECQoAAAAsAAAAABAAEAAAAzMIumIlK8oyhpHsnFZfhYumCYUhDAQxRIdhHBGqRoKw0R8DYlJd8z0fMDgsGo/IpHI5TAAAIfkECQoAAAAsAAAAABAAEAAAAzIIunInK0rnZBTwGPNMgQwmdsNgXGJUlIWEuR5oWUIpz8pAEAMe6TwfwyYsGo/IpFKSAAAh+QQJCgAAACwAAAAAEAAQAAADMwi6IMKQORfjdOe82p4wGccc4CEuQradylesojEMBgsUc2G7sDX3lQGBMLAJibufbSlKAAAh+QQJCgAAACwAAAAAEAAQAAADMgi63P7wCRHZnFVdmgHu2nFwlWCI3WGc3TSWhUFGxTAUkGCbtgENBMJAEJsxgMLWzpEAACH5BAkKAAAALAAAAAAQABAAAAMyCLrc/jDKSatlQtScKdceCAjDII7HcQ4EMTCpyrCuUBjCYRgHVtqlAiB1YhiCnlsRkAAAOwAAAAAAAAAAAA=="/>
                            <button v-show="!this.form.submitting || this.form.submitting" :disabled="$v.form.$invalid"
                                    class="btn btn-success"
                                    type="submit">
                                Sign up now
                            </button>
                        </div>
                        <b-btn v-if="form.env" @click="form.showFormInfoAlert = !form.showFormInfoAlert" variant="info"
                               class="m-1"
                               style="position: fixed; right:10px; bottom:10px;">
                            Show form info
                        </b-btn>
                    </form>
                    <div class="alert alert-success" role="alert"><strong>Already have an account ?</strong>
                        <router-link :to="{name: 'login'}">
                            <b-btn variant="info" class="m-1">Signin here</b-btn>
                        </router-link>
                    </div>

                    <b-alert variant="info"
                             dismissible
                             :show="form.showFormInfoAlert"
                             @dismissed="form.showFormInfoAlert=false"
                             style="position: fixed; right:10px; bottom:50px; width:300px; max-height: 500px; overflow: scroll">
                        <pre class="text-left">{{this.$v}}</pre>
                    </b-alert>
                </b-col>
            </b-row>
        </card>
</template>

<script>
    import {required, email} from "vuelidate/lib/validators";
    import {isEmailAlreadyRegistered} from "./validators";
    import Card from "../Card";

    const validations = {
        form: {
            showFormInfoAlert:true,
            email: {required, email, isEmailAlreadyRegistered},
            password: {required},
            password_confirmation: {required},
            username: {required}
        }
    };

    const devEnv = process.env.NODE_ENV === 'development';//TODO: code this a better way :(

    export default {
        name: "RegisterForm",
        components: {Card},
        data() {
            return {
                form: {
                    username: "",
                    email: "",
                    password: "",
                    password_confirmation: "",
                    showFormInfoAlert: false,
                    submitting: false,
                    env: devEnv, //TODO: code this a better way :(
                }
            };
        },
        validations,
        methods: {
            register: function () {
                let data = {
                    username: this.form.username,
                    email: this.form.email,
                    password: this.form.password,
                    password_confirmation: this.form.password_confirmation,
                    is_admin: false
                }
                this.$store.dispatch('register', data)
                    .then( () => {
                            this.$store.commit('request_success'),
                                this.$toasted.success(
                                    'Success !.',
                                    {
                                        closeOnSwipe: false,
                                        action: {
                                            text: 'Ok, take me to the homepage',
                                            push: {
                                                name: 'home',
                                                dontClose: false,
                                                duration:5000
                                            }
                                        }
                                    })
                    })
                    .catch((err) => {
                            this.$store.commit('request_error')
                            this.$v.form.$reset();
                            this.$v.form.$touch();
                            this.$toasted.error(
                                err,
                                {
                                    closeOnSwipe: true,
                                    duration:5000
                                })
                        }
                    )
            }
        },
        mounted() {
        }
    };
</script>
